
#include <stdio.h>
#include <dlfcn.h>

#ifndef HAIKU
typedef struct {
const char *   dli_fname;
void *         dli_fbase;
const char *   dli_sname;
void *         dli_saddr;
} Dl_info;
#endif

int main()
{

void *ptr;
void *symbol;
Dl_info info;

ptr = dlopen("./test.lib.so", RTLD_LAZY);

if(ptr==NULL)
{
    printf( "%s\n", dlerror() );
    return 1;
}

symbol = dlsym( ptr,  "exoprted_symbol") ;

if ( symbol == NULL )
{
    printf( "%s\n", dlerror() );
    return 1;
}

if( ! dladdr( symbol, &info ) )
{
    printf( "Error mapping address.\n" );
//    return 0;
}

printf( "fname=%s\n",  info.dli_fname );
printf( "fbase=%p\n",  info.dli_fbase );
printf( "sname=%s\n",  info.dli_sname );
printf( "saddr=%p\n", info.dli_saddr );

return 0;
}